/* Copyright (C) 2004 - 2007  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.foundation;

/**
 * @exclude
 */
public class KeySpecHashtable4 extends Hashtable4 {
	private KeySpecHashtable4() {
		super((DeepClone)null);
	}
	
	public KeySpecHashtable4(int a_size) {
		super(a_size);
	}
	
    public void put(KeySpec spec,byte value) {
    	super.put(spec,new Byte(value));
    }

    public void put(KeySpec spec,boolean value) {
    	super.put(spec,new Boolean(value));
    }

    public void put(KeySpec spec,int value) {
    	super.put(spec,new Integer(value));
    }

    public void put(KeySpec spec, Object value) {
    	super.put(spec,value);
    }

    public byte getAsByte(KeySpec spec) {
    	return ((Byte)get(spec)).byteValue();
    }

    public boolean getAsBoolean(KeySpec spec) {
    	return ((Boolean)get(spec)).booleanValue();
    }

    public int getAsInt(KeySpec spec) {
    	return ((Integer)get(spec)).intValue();
    }

    public TernaryBool getAsTernaryBool(KeySpec spec) {
    	return (TernaryBool)get(spec);
    }

    public String getAsString(KeySpec spec) {
    	return (String)get(spec);
    }

    public Object get(KeySpec spec) {
        Object value=super.get(spec);
        if(value == null){
            value = spec.defaultValue();
            if(value != null){
                super.put(spec, value);
            }
        }
        return value;
    }
    
    public Object deepClone(Object obj) {
    	return deepCloneInternal(new KeySpecHashtable4(), obj);
    }
}
