/* Copyright (C) 2004 - 2007  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.internal;

import com.db4o.internal.handlers.*;



/**
 * improves YInt performance slightly by not doing checks
 * and by doing the comparison with a substraction
 * @exclude
 */
public class PrimitiveIntHandler extends IntHandler{
	
	public PrimitiveIntHandler(ObjectContainerBase stream) {
		super(stream);
	}
	
	public Comparable4 prepareComparison(Object obj) {
		_currentInteger = ((Integer)obj);
		_currentInt = _currentInteger.intValue();
		return this;
	}
	
	private Integer _currentInteger;
	
	private int _currentInt;

	public int compareTo(Object obj) {
		return val(obj) - _currentInt;
	}

	public Object current() {
		return _currentInteger;
	}

	public boolean isEqual(Object obj) {
		return val(obj) == _currentInt;
	}

	public boolean isGreater(Object obj) {
		return val(obj) > _currentInt;
	}

	public boolean isSmaller(Object obj) {
		return val(obj) < _currentInt;
	}
	
}
