/* Copyright (C) 2004 - 2007  db4objects Inc.  http://www.db4o.com

This file is part of the db4o open source object database.

db4o is free software; you can redistribute it and/or modify it under
the terms of version 2 of the GNU General Public License as published
by the Free Software Foundation and as clarified by db4objects' GPL 
interpretation policy, available at
http://www.db4o.com/about/company/legalpolicies/gplinterpretation/
Alternatively you can write to db4objects, Inc., 1900 S Norfolk Street,
Suite 350, San Mateo, CA 94403, USA.

db4o is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */
package com.db4o.internal;

import com.db4o.ext.*;
import com.db4o.internal.handlers.*;
import com.db4o.internal.marshall.*;
import com.db4o.internal.slots.*;


/**
 * @exclude
 */
public class VersionFieldMetadata extends VirtualFieldMetadata {

    VersionFieldMetadata(ObjectContainerBase stream) {
        super();
        i_name = VirtualField.VERSION;
        i_handler = new LongHandler(stream);
    }
    
    public void addFieldIndex(MarshallerFamily mf, ClassMetadata yapClass, StatefulBuffer writer, Slot oldSlot) {
        writer.writeLong(writer.getStream().generateTimeStampId());
    }
    
    public void delete(MarshallerFamily mf, StatefulBuffer a_bytes, boolean isUpdate) {
        a_bytes.incrementOffset(linkLength());
    }

    void instantiate1(Transaction a_trans, ObjectReference a_yapObject, Buffer a_bytes) {
        a_yapObject.virtualAttributes().i_version = a_bytes.readLong();
    }

    void marshall1(ObjectReference a_yapObject, StatefulBuffer a_bytes, boolean a_migrating, boolean a_new) {
        ObjectContainerBase stream = a_bytes.getStream().i_parent;
        VirtualAttributes va = a_yapObject.virtualAttributes();
        if (! a_migrating) {
            va.i_version = stream.generateTimeStampId();
        }
        if(va == null){
            a_bytes.writeLong(0);
        }else{
            a_bytes.writeLong(va.i_version);
        }
    }

    public int linkLength() {
        return Const4.LONG_LENGTH;
    }
    
    void marshallIgnore(Buffer writer) {
        writer.writeLong(0);
    }


}